<template>
  <el-select
    v-model="selected"
    class="size-select"
    placeholder="请选择"
    @change="select"
    :style="styles"
    filterable
    remote
    :remote-method="search"
    clearable
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :label="item.code"
      :value="item.id"
    >
      <span>{{ item.code }}</span>
    </el-option>
  </el-select>
</template>

<script>
import { searchActivities } from "@/api/examwork-activity";

export default {
  name: "ActivitySelect",
  props: {
    value: String,
    examId: String,
    styles: { type: String },
  },
  data() {
    return {
      optionList: [],
      selected: "",
    };
  },
  async created() {
    this.search();
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      },
    },
    examId() {
      this.search();
    },
  },
  methods: {
    async search(query) {
      const res = await searchActivities({
        examId: this.examId,
        code: query,
        pageNumber: 1,
        pageSize: 30,
      });
      this.optionList = res?.data.data.records;
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit("change", this.selected);
    },
  },
};
</script>

<style></style>
